﻿using C1.C1Preview;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GetFirstRowOfEachPage
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var _printDocument = new C1PrintDocument();
            RenderTable rt = new RenderTable();
            rt.Style.FontSize = 14;
            rt.CellStyle.Spacing.All = new Unit(2, C1.C1Preview.UnitTypeEnum.Mm);
            rt.Style.GridLines.All = new C1.C1Preview.LineDef(new Unit(0.3, UnitTypeEnum.Mm), Color.Black);
            rt.Cols[0].Width = new Unit(2, C1.C1Preview.UnitTypeEnum.Cm);
            rt.Cols[1].Width = new Unit(5, C1.C1Preview.UnitTypeEnum.Cm);
            rt.Cols[2].Width = new Unit(2, C1.C1Preview.UnitTypeEnum.Cm);
            rt.Cols[3].Width = new Unit(2, C1.C1Preview.UnitTypeEnum.Cm);
            // Header
            int row = rt.Rows.Count;
            rt.Cells[row, 0].Text = "No.";
            rt.Cells[row, 1].Text = "Description";
            rt.Cells[row, 2].Text = "Count";
            rt.Cells[row, 3].Text = "Price";
            rt.Rows[row].Style.FontBold = true;
            rt.Rows[row].Style.BackColor = Color.LightGray;
            // Rows
            for (int n = 1; n < 64; n++)
            {
                row = rt.Rows.Count;
                rt.Cells[row, 0].Text = string.Format("{0}", n);
                rt.Cells[row, 1].Text = string.Format("Name {0}", n);
                rt.Cells[row, 2].Text = string.Format("{0}", n * 2);
                rt.Cells[row, 3].Text = string.Format("{0}", 1000);
               
            }
            _printDocument.Body.Children.Clear();
            _printDocument.PageLayout.PageSettings.Landscape = true;
            _printDocument.PageLayout.PageSettings.PaperKind = System.Drawing.Printing.PaperKind.A4;
            _printDocument.Body.Children.Add(rt);
            _printDocument.PageAdded += _printDocument_PageAdded;
            _printDocument.DocumentStarting += _printDocument_DocumentStarting;
            c1PrintPreviewControl1.Document = _printDocument;
        }

        private void _printDocument_DocumentStarting(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }

        private void _printDocument_PageAdded(C1PrintDocument sender, PageEventArgs e)
        {
            foreach (RenderFragment fragment in e.Page.Fragments)
            {
                foreach (object child in fragment.Children)
                {
                    if (child.GetType() == typeof(RenderTextFragment))                    {
                        RenderText text = ((RenderTextFragment)child).RenderObject;
                        listBox1.Items.Add("page: " + (e.Page.Index + 1) + " , starting row: " + text.TableRow);
                        break;
                    }
                }
            }
        }
    }
}
